package com.io.yutian.auchestshop.gui;

import com.io.yutian.auchestshop.AuChestShop;
import com.io.yutian.auchestshop.shop.ShopType;
import com.io.yutian.aulib.gui.Gui;
import com.io.yutian.aulib.gui.button.Button;
import com.io.yutian.aulib.lang.Lang;
import com.io.yutian.aulib.util.ItemStackBuilder;
import com.io.yutian.aulib.util.PlayerInventoryUtil;
import net.kyori.adventure.text.Component;
import org.bukkit.Material;
import org.bukkit.block.Block;
import org.bukkit.entity.Player;
import org.bukkit.event.inventory.InventoryCloseEvent;
import org.bukkit.inventory.ItemStack;

public class CreateShopGui extends Gui {

    private Block block;
    private ItemStack itemStack;

    private Runnable runnable;

    protected boolean created = false;

    public CreateShopGui(Player player, Block block, ItemStack itemStack, Runnable runnable) {
        super(player, Component.text("创建商店"), 27);
        this.block = block;
        this.itemStack = itemStack.clone();
        this.itemStack.setAmount(1);
        this.runnable = runnable;
        init();
        initButton();
    }

    @Override
    public void init() {
        addButton(11, new Button(new ItemStackBuilder(Material.DIAMOND).setDisplayName("§a出售").build()).click((player1, clickType) -> {
            created = true;
            AuChestShop.getShopManager().createShop(player1, block, ShopType.SELLING);
            player1.closeInventory();
            player.sendMessage(Lang.get("auchestshop.create-shop.success"));
            runnable.run();
        }));
        addButton(15, new Button(new ItemStackBuilder(Material.EMERALD).setDisplayName("§a收购").build()).click((player1, clickType) -> {
            created = true;
            AuChestShop.getShopManager().createShop(player1, block, ShopType.BUYING);
            player1.closeInventory();
            player.sendMessage(Lang.get("auchestshop.create-shop.success"));
            runnable.run();
        }));
    }

    @Override
    public void close(InventoryCloseEvent event) {
        if (!created) {
            block.setType(Material.AIR);
            PlayerInventoryUtil.giveItemStack(player, itemStack);
        }
    }
}
