package com.io.yutian.auchestshop.shop;

import org.bukkit.Location;

import java.util.Objects;

public class ShopLocation {

    private final String world;
    private final int x;
    private final int y;
    private final int z;

    public ShopLocation(String world, int x, int y, int z) {
        this.world = world;
        this.x = x;
        this.y = y;
        this.z = z;
    }

    public static ShopLocation fromLocation(Location location) {
        return new ShopLocation(location.getWorld().getName(), location.getBlockX(), location.getBlockY(), location.getBlockZ());
    }

    public String getWorld() {
        return world;
    }

    public int getX() {
        return x;
    }

    public int getY() {
        return y;
    }

    public int getZ() {
        return z;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;

        ShopLocation that = (ShopLocation) o;
        return getX() == that.getX() && getY() == that.getY() && getZ() == that.getZ() && Objects.equals(getWorld(), that.getWorld());
    }

    @Override
    public int hashCode() {
        int result = Objects.hashCode(getWorld());
        result = 31 * result + getX();
        result = 31 * result + getY();
        result = 31 * result + getZ();
        return result;
    }
}
