package com.io.yutian.auchestshop.shop.log;

import org.json.JSONObject;

import java.util.UUID;

public class ShopPlayerLog {

    private UUID uuid;
    private int amount;
    private double total;
    private long time;

    public ShopPlayerLog(UUID uuid, int amount, double total, long time) {
        this.uuid = uuid;
        this.amount = amount;
        this.total = total;
        this.time = time;
    }

    public static ShopPlayerLog fromJSON(JSONObject json) {
        return new ShopPlayerLog(UUID.fromString(json.getString("uuid")), json.getInt("amount"), json.getDouble("total"), json.getLong("time"));
    }

    public JSONObject toJSON() {
        JSONObject json = new JSONObject();
        json.put("uuid", uuid.toString());
        json.put("amount", amount);
        json.put("total", total);
        json.put("time", time);
        return json;
    }

}
