package com.io.yutian.auchestshop.util;

import com.io.yutian.aulib.nbt.NBTItem;
import com.io.yutian.aulib.nbt.NBTString;
import org.bukkit.Material;
import org.bukkit.Tag;
import org.bukkit.block.Block;
import org.bukkit.block.data.BlockData;
import org.bukkit.block.data.Directional;
import org.bukkit.inventory.Inventory;
import org.bukkit.inventory.ItemStack;
import org.jetbrains.annotations.NotNull;

import java.util.EnumSet;

public class ShopUtil {

    private static final EnumSet<Material> SHOPABLES = EnumSet.noneOf(Material.class);

    static {
        SHOPABLES.add(Material.CHEST);
        SHOPABLES.add(Material.TRAPPED_CHEST);
    }

    public static void takeShopItemStack(Inventory inventory, ItemStack itemStack, int amount) {
        int index = -1;
        int a = amount;
        while (index < inventory.getSize() && a > 0) {
            ++index;
            ItemStack i = inventory.getItem(index);
            if (i != null && ItemStackUtil.matches(itemStack, i)) {
                int k = i.getAmount();
                if (k < a) {
                    i.setType(Material.AIR);
                } else {
                    int l = k - a;
                    i.setAmount(l);
                }
                a -= k;
            }
        }

    }

    public static boolean isShopItem(ItemStack itemStack) {
        NBTItem nbtItem = new NBTItem(itemStack);
        if (!nbtItem.has("item_type", NBTString.TYPE_ID)) {
            return false;
        }
        String itemType = (String) nbtItem.get("item_type").getValue();
        return itemType.equalsIgnoreCase("chest_shop");
    }

    public static Block getAttached(@NotNull Block block) {
        BlockData blockData = block.getBlockData();
        if (blockData instanceof final Directional directional) {
            return block.getRelative(directional.getFacing().getOppositeFace());
        } else {
            return null;
        }
    }

    public static boolean isWallSign(@NotNull Material material) {
        return Tag.WALL_SIGNS.isTagged(material);
    }

    public static boolean isShoppables(@NotNull Material material) {
        return SHOPABLES.contains(material);
    }

    public static EnumSet<Material> getShopables() {
        return SHOPABLES;
    }

}
