package com.io.yutian.auchestshop.util;

import com.io.yutian.auchestshop.AuChestShop;
import com.io.yutian.auchestshop.shop.Shop;
import com.io.yutian.auchestshop.shop.ShopType;
import com.io.yutian.aulib.lang.Lang;
import com.io.yutian.aulib.util.PlayerInventoryUtil;
import net.milkbowl.vault.economy.EconomyResponse;
import org.bukkit.entity.Player;
import org.bukkit.inventory.Inventory;
import org.bukkit.inventory.ItemStack;

import java.util.List;

public class TradeHelper {

    public static void trade(Player player, Shop shop, int amount) {
        ShopType shopType = shop.getShopType();
        Inventory shopInventory = shop.getInventory();
        if (shopType == ShopType.SELLING) {
            ItemStack itemStack = shop.getItem();
            int freeSize = PlayerInventoryUtil.getFreeSize(player);
            if (freeSize < amount) {
                player.sendMessage(Lang.get("auchestshop.action.error-9", amount, ItemStackUtil.getItemName(itemStack)));
                return;
            }
            int allAmount = ItemStackUtil.countItems(shopInventory, itemStack);
            if (allAmount < amount) {
                player.sendMessage(Lang.get("auchestshop.action.error-11", amount, ItemStackUtil.getItemName(itemStack)));
                return;
            }
            double allPrice = shop.getPrice() * amount;
            EconomyResponse economyResponse = AuChestShop.getEconomy().withdrawPlayer(player, allPrice);
            if (!economyResponse.transactionSuccess()) {
                player.sendMessage(Lang.get("auchestshop.action.error-7", amount, ItemStackUtil.getItemName(itemStack)));
                return;
            }
            List<ItemStack> itemStacks = ItemStackUtil.mergeItems(itemStack, amount);
            ShopUtil.takeShopItemStack(shopInventory, itemStack, amount);
            for (ItemStack item : itemStacks) {
                PlayerInventoryUtil.giveItemStack(player, item);
            }
            player.sendMessage(Lang.get("auchestshop.action.message-5", amount, ItemStackUtil.getItemName(itemStack)));
        } else if (shopType == ShopType.BUYING) {
            ItemStack itemStack = shop.getItem();
            int freeSize = ItemStackUtil.countSpace(shopInventory, itemStack);
            if (freeSize < amount) {
                player.sendMessage(Lang.get("auchestshop.action.error-10", amount, ItemStackUtil.getItemName(itemStack)));
                return;
            }
            int allAmount = ItemStackUtil.countItems(player.getInventory(), itemStack);
            if (allAmount < amount) {
                player.sendMessage(Lang.get("auchestshop.action.error-12", amount, ItemStackUtil.getItemName(itemStack)));
                return;
            }
            double allPrice = shop.getPrice() * amount;
            EconomyResponse economyResponse = AuChestShop.getEconomy().depositPlayer(player, allPrice);
            if (!economyResponse.transactionSuccess()) {
                player.sendMessage(Lang.get("auchestshop.action.error-7", amount, ItemStackUtil.getItemName(itemStack)));
                return;
            }
            PlayerInventoryUtil.takeItemStack(player, (itemStack1 -> ItemStackUtil.matches(itemStack1, itemStack)), amount);
            List<ItemStack> itemStacks = ItemStackUtil.mergeItems(itemStack, amount);
            for (ItemStack item : itemStacks) {
                shopInventory.addItem(item);
            }
            player.sendMessage(Lang.get("auchestshop.action.message-4", amount, ItemStackUtil.getItemName(itemStack)));
        }
    }

}
